/*
 *  sort.c	- sorce code for all things relating to sorting
 *
 *	Project 1
 *	CSE 326, Winter 2008
 *	University of Washington
 *
 *  Created by Ilya Maykov on 1/6/05.
 *  Modified by Gyanit Singh.
 *  Copyright 2005 University of Washington. All rights reserved.
 *
 */


#include <assert.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#include "sort.h"
#include "options.h"
#include "utils.h"


int
main(int argc, char **argv);


int
BubbleSort(int *array, int size) {
    assert(array != NULL);
    assert(size > 0);
    if(array == NULL || size <= 0) return -1;
    int i, j;
    for(i = 0; i < size; ++i) {
        for(j = 0; j < size - 1 - i; ++j) {
            if(array[j+1] < array[j]) {
                int temp = array[j];
                array[j] = array[j+1];
                array[j+1] = temp;
            }
        }
    }
    return 0;
}

int
InsertionSort(int *array, int size) {
    //TODO:	Implement this
    fprintf(stdout, "%s: not implemented\n", __FUNCTION__);
    return -1;
}

int
QuickSortOne(int *array, int size) {
    //TODO:	Implement this
    fprintf(stdout, "%s: not implemented\n", __FUNCTION__);
    return -1;
}

int
QuickSortTwo(int *array, int size) {
    //TODO:	Implement this
    fprintf(stdout, "%s: not implemented\n", __FUNCTION__);
    return -1;
}



int
IterativeMergeSort(int *array, int size) {
    //TODO:	Implement this
    fprintf(stdout, "%s: not implemented\n", __FUNCTION__);
    return -1;
}

int
RecursiveMergeSort(int *array, int size) {
    //TODO:	Implement this
    fprintf(stdout, "%s: not implemented\n", __FUNCTION__);
    return -1;
}


/*
 * Returns 1 if array sorted by sortOrder and 0 otherwise
 */
int
VerifySortOrder(int *array, int size, SortOrder sortOrder) {
    int i, okay;

    okay = 1;
    if(sortOrder == kDecreasingOrder) {
        for(i = 1; i < size; ++i) {
            assert(array[i] <= array[i-1]);
            if(array[i] > array[i-1]) okay = 0;
        }
    } else if(sortOrder == kIncreasingOrder) {
        for(i = 1; i < size; ++i) {
            assert(array[i] >= array[i-1]); 
            if(array[i] < array[i-1]) okay = 0;
        }
    } else if(sortOrder == kFlatOrder) {
        for(i = 1; i < size; ++i) {
            assert(array[i] == array[i-1]);
            if(array[i] != array[i-1]) okay = 0;
        }
    } else {
        fprintf(stderr, "Error: unknown sort order %d\n", sortOrder);
        okay = 0;
        assert(0);
    }
    return okay;
}


int
main(int argc, char **argv) {
    int *array, err;
    time_t now;
    Options *pOpts;
    int start_time;
    
    pOpts = (Options*) malloc(sizeof(Options));
    assert(pOpts);
    
    err = ParseOptions(argc, (const char**) argv, pOpts);
    if(err)
        exit(err);
    PrintOptions(pOpts, stdout);
    
    
    time(&now);
    srand48(now);
    
    array = CreateArray(pOpts->arraySize, pOpts->sortOrder);
    assert(array);
 
    start_time = CurrentTime();
    switch (pOpts->sortType) {
    case kBubbleSort: 
        BubbleSort(array, pOpts->arraySize);
        break;
    default:
        printf("Sorting is not implemented, exiting\n");
        return 1;
    } 
    printf("Sort took %g seconds\n",
	   (CurrentTime()-start_time)/1000.0);

    assert(VerifySortOrder(array,pOpts->arraySize,
                           kIncreasingOrder));

    free(array);
    free(pOpts);
    return 0;
}
