/*
 *  types.h - header definitions for enum types to program options
 *
 *	Project 1, Part 1
 *	CSE 326, Winter 2008
 *	University of Washington
 *
 *  Created by Ilya Maykov on 1/6/05.
 *  Copyright 2005 University of Washington. All rights reserved.
 *
 */

#ifndef _TYPES_H_INCLUDED_
#define _TYPES_H_INCLUDED_

/*
 *	Enumeration of the different sort types.
 */
typedef enum
{
	kInsertionSort = 0,
	kQuickSortOne,
	kQuickSortTwo,
	kIterativeMergeSort,
	kRecursiveMergeSort,
	kBubbleSort,
	//
	// constants for new sort types may be inserted here
	//
	kInvalidSort	// this must remain at the end
} SortType;

/*
 *	Enumeration of the different sort orders.
 */
typedef enum
{
	kRandomOrder = 0,	// random elements
	kDecreasingOrder,	// for each i, j between 0 and arraySize-1, if i < j then array[j] <= array[i]
	kFlatOrder,			// all elements are equal
	kIncreasingOrder,	// for each i, j between 0 and arraySize-1, if i < j then array[j] >= array[i]
	//
	// constants for new sort orders may be inserted here
	//
	kInvalidOrder		// this must remain at the end
} SortOrder;

#define kNumSortTypes (kInvalidSort + 1)
#define kNumSortOrders (kInvalidOrder + 1)

/*
 *	String constants for printing the sort types.
 */
extern const char* const kSortTypeStrings[kNumSortTypes];

/*
 *	String constants for printing the sort orders.
 */
extern const char* const kSortOrderStrings[kNumSortOrders];

#endif	//_TYPES_H_INCLUDED_
