/*
 *  utils.c - source code for miscellaneous utility functions
 *
 *	Project 1
 *	CSE 326, Winter 2008
 *	University of Washington
 *
 *  Created by Ilya Maykov on 1/6/05.
 *  Copyright 2005 University of Washington. All rights reserved.
 *
 */

#include <sys/time.h>
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include "utils.h"
#include "types.h"


int
CurrentTime(void) {
    struct timeval tv;
    int err;
    err = gettimeofday(&tv, NULL);
    assert(err == 0);
    return tv.tv_sec * 1000 + tv.tv_usec / 1000;
}


int*
CreateArray(int size, SortOrder order) {
    int i, mod, val, *array;
    assert(size > 0);
    assert((unsigned int) order < kInvalidOrder);
    if(size <= 0 || (unsigned int) order >= kInvalidOrder) {
        assert(0);
        return NULL;
    }
    array = (int*) malloc(sizeof(int) * size);
    assert(array);
    mod = 10;
    val = 0;
    if(order == kDecreasingOrder) {
        for(i = 0; i < size; ++i) {
            array[i] = val;
            val -= lrand48() % mod;
        }
    } else if(order == kIncreasingOrder) {
        for(i = 0; i < size; ++i) {
            array[i] = val;
            val += lrand48() % mod;
        }
    } else if(order == kFlatOrder) {
        val = lrand48() % 10;
        for(i = 0; i < size; ++i) {
            array[i] = val;
        }
    } else if(order == kRandomOrder) {
        for(i = 0; i < size; ++i) {
            array[i] = mrand48();
        }
    }
    return array;
}


int 
PrintArray(const int *array, int size, FILE *stream) {
    int i;
    assert(array != NULL);
    assert(size > 0);
    assert(stream != NULL);
    for(i = 0; i < size; ++i) {
        fprintf(stream, "%d\n", array[i]);
    }
    return 0;
}
